XA_Bookstore/bookstore/accounts/urls.py
from django.urls import path

# view accounts
from .import views

app_name = 'accounts'

urlpatterns = [
    path('signup/', views.accounts_signup, name='signup'),
    path('login/', views.accounts_login, name='login'),
    path('logout/', views.accounts_logout, name='logout')
]

XA_Bookstore/bookstore/books/urls.py
from django.urls import path
from .import views

app_name = 'books'

urlpatterns = [
    path('', views.book_index, name='index'),               # books:index
    path('create/', views.book_create, name='create'),      # books:create
    path('edit/<int:id>', views.book_edit, name='edit'), # books:edit
    path('delete/<int:id>', views.book_delete, name='delete'),
    path('<int:id>', views.book_details, name='details')
]

XA_Bookstore/bookstore/bookstore/urls.py
from django.contrib import admin
from django.urls import path, include

# import view bookstore
from .import views

# import upload image cover
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    # Bookstore
    path('', views.homepage, name='homepage'),

    # Books
    path('books/', include('books.urls')),

    # Accounts
    path('accounts/', include('accounts.urls')),

    # App Admin
    path('admin/', admin.site.urls),
]

# for upload file image cover
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

XA_Bookstore/bookstore/accounts/models.py
from django.db import models

# Create your models here.

XA_Bookstore/bookstore/books/models.py
from django.db import models

# Create your models here.
class Book(models.Model):
    title = models.CharField(max_length=100)
    ISBN = models.CharField(max_length=10)
    author = models.CharField(max_length=50)
    cover = models.ImageField(default="no_image_found.png", blank=True)

    def __str__(self):
        return self.title

XA_Bookstore/bookstore/books/forms.py
from django.forms import ModelForm
from .import models

class CreateBook(ModelForm):
    class Meta:
        model = models.Book
        fields = ['title', 'ISBN', 'author', 'cover']

class EditBook(ModelForm):
    class Meta:
        model = models.Book
        fields = ['title', 'ISBN', 'author', 'cover']

XA_Bookstore/bookstore/accounts/views.py
from django.shortcuts import render, redirect

# import auth
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.contrib.auth import login, logout

# Create your views here.
def accounts_signup(request):
    if request.method == 'POST':
        form = UserCreationForm(request.POST)
        if form.is_valid():
            user = form.save()
            login(request, user)
            return redirect('books:index')
    else:
        form = UserCreationForm()
    
    return render(request, 'accounts/signup.html', {'form' : form, 'title' : 'XA | Signup' } )

def accounts_login(request):
    if request.method == 'POST':
        form = AuthenticationForm(data=request.POST)
        if form.is_valid():
            user = form.get_user()
            login(request, user)
            return redirect('books:index')
    else:
        form = AuthenticationForm()
    
    return render(request, 'accounts/login.html', {'form' : form, 'title' : 'XA | Login' } )

def accounts_logout(request):
    if request.method == 'POST':
        logout(request)
        return redirect('homepage')

XA_Bookstore/bookstore/books/views.py
from django.shortcuts import render, redirect

# models Book
from .models import Book

# User Login
from django.contrib.auth.decorators import login_required

# form
from .import forms

# Create your views here.
def book_index(request):
    books = Book.objects.all().order_by('title')
    return render(request, 'books/index.html', {'books' : books, 'title' : 'XA | Book List'})

def book_details(request, id):
    book = Book.objects.get(id=id)
    return render(request, 'books/details.html', {'book' : book, 'title' : 'XA | Book Details'})

@login_required(login_url="/accounts/login/")
def book_create(request):
    if request.method == "POST":
        form = forms.CreateBook(request.POST, request.FILES)
        if form.is_valid():
            form.save()
            return redirect('books:index')
    else:
        form = forms.CreateBook()
    
    return render(request, 'books/create.html', {'form' : form, 'title' : 'XA | New Book'})

@login_required(login_url="/accounts/login/")
def book_edit(request, id):
    book = Book.objects.get(id=id)
    print('========= Book Edit =========' )
    print(book)
    if request.method == 'POST':
        form = forms.EditBook(request.POST, request.FILES, instance=book)
        if form.is_valid():
            form.save()
            return redirect('books:index')
    else:
        form = forms.EditBook(instance=book)
    
    return render(request, 'books/edit.html', {'form' : form, 'title' : 'XA | Edit Book'})

@login_required(login_url="/accounts/login")
def book_delete(request, id):
    book = Book.objects.get(id=id)
    book.delete()
    return redirect('books:index')

XA_Bookstore/bookstore/bookstore/views.py
from django.shortcuts import render

def homepage(request):
    return render(request, 'homepage.html', {'title' : 'XA | Bookstore'})

XA_Bookstore/bookstore/accounts/templates/accounts/login.html
{% extends 'base_layout.html' %}

{% block content %}
<h1>Login</h1>

<form   class="site-form"
        action="{% url 'accounts:login' %}"
        method="POST">
        {% csrf_token %}
        <table>
            {{ form.as_table }}
        </table>
        <input type="submit" class="btn btn-primary" value="Login">
</form>
{% endblock %}

XA_Bookstore/bookstore/accounts/templates/accounts/signup.html
{% extends 'base_layout.html' %}

{% block content %}
<h1>Signup</h1>

<form   class="site-form"
        action="{% url 'accounts:signup' %}"
        method="POST">
        {% csrf_token %}
        <table>
            {{ form.as_table }}
        </table>
        <input type="submit" class="btn btn-primary" value="Signup">
</form>
{% endblock %}

XA_Bookstore/bookstore/templates/base_layout.html
{% include 'base_part_header.html' %}

<body class="d-flex flex-column min-vh-100">
    
    {% include 'base_part_nav.html' %}

    <div class="container">
        <main role="main" class="pb-3">
            {% block content %}
            {% endblock %}
        </main>
    </div>
    
</body>

{% include 'base_part_footer.html' %}

</html>

XA_Bookstore/bookstore/templates/base_part_footer.html
{% load static %}

{% block footer %}
<footer class="border-top footer text-muted mt-auto">
    <div class="container">
        &copy; 2020 - XA Bookstore on Python-Django with Bootstrap
    </div>
</footer>
<script src="{% static 'js/jquery.min.js' %}"></script>
<script src="{% static 'js/bootstrap.min.js' %}"></script>
{% endblock %}

XA_Bookstore/bookstore/templates/base_part_header.html
{% load static %}

{% block header %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ title }}</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/bootstrap.min.css' %}">

</head>
{% endblock %}

XA_Bookstore/bookstore/templates/base_part_nav.html
{% load static %}

{% block nav %}
<nav class="navbar navbar-expand-sm navbar-toggleable-sm
                navbar-light bg-white border-bottom
                box-shadow mb-3">
        <div class="container">
            <a class="navbar-brand" href="{% url 'homepage' %}">
                <img src="{% static 'images/logo.jpg' %}" width="100" height="50">
            </a>
            <button class="navbar-toggler" type="button"
                    data-toggle="collapse"
                    data-target=".navbar-collapse"
                    aria-controls="navbarSupportedContent"
                    aria-expanded="false"
                    aria-label="Toggle navigation">
                <span class="navbar-tggler-icon"></span>
            </button>
            <div class="navbar-collapse collapse justify-content-between">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link text-dark" href="{% url 'books:index' %}">Book</a>
                    </li>
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link text-dark" href="{% url 'books:create' %}">Add New Book</a>
                    </li>
                    {% endif %}
                </ul>
                <ul class="navbar-nav">
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link text-dark" href="#">Welcome, {{ user }}</a>
                    </li>
                    <li class="nav-item">
                        <form class="logout-link" action="{% url 'accounts:logout' %}" method="POST">
                            {% csrf_token %}
                            <button type="submit" class="btn btn-link text-dark">Logout</button>
                        </form>
                    </li>
                    {% else %}
                    <li class="nav-item">
                        <a class="nav-link text-dark" href="{% url 'accounts:signup' %}">Signup</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link text-dark" href="{% url 'accounts:login' %}">Login</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </div>

</nav>
{% endblock %}

XA_Bookstore/bookstore/templates/homepage.html
{% extends 'base_layout.html' %}

{% block content %}
    <h1>Welcome to Xsis Bookstore</h1>
    <p>This is the Home Page</p>
{% endblock %}